require 'spec_helper'

describe 'jenkins' do
  context 'supported operating systems' do
    on_supported_os.each do |os, facts|
      context "on #{os}" do
        let(:facts) do
          facts
        end

        context "jenkins class without any parameters" do
          it { is_expected.to compile.with_all_deps }

          it { is_expected.to contain_class('jenkins::params') }
          it { is_expected.to contain_class('jenkins::install').that_comes_before('Class[jenkins::config]') }
          it { is_expected.to contain_class('jenkins::config') }
          it { is_expected.to contain_class('jenkins::service').that_subscribes_to('Class[jenkins::config]') }

          it { is_expected.to contain_service('jenkins') }
          it { is_expected.to contain_package('jenkins').with_ensure('present') }
        end
      end
    end
  end

  # context 'unsupported operating system' do
  #   describe 'jenkins class without any parameters on Solaris/Nexenta' do
  #     let(:facts) do
  #       {
  #         osfamily: 'Solaris',
  #         operatingsystem: 'Nexenta',
  #       }
  #     end
  #
  #     it { expect { is_expected.to contain_package('jenkins') }.to raise_error(Puppet::Error, /Nexenta not supported/) }
  #   end
  # end
end
